use std::io;
use std::io::Write;

use ollama_rs::generation::chat::request::ChatMessageRequest;
use ollama_rs::generation::chat::ChatMessage;
use ollama_rs::Ollama;

#[tokio::main]
async fn main() {
    let mut ollama = Ollama::default();

    let model = "qwen2.5:0.5b".to_string();
    let mut history = vec![];

    loop {
        print!("Enter your prompt: ");
        io::stdout().flush().unwrap();
        let mut prompt = String::new();
        io::stdin().read_line(&mut prompt).unwrap();

        let res = ollama
            .send_chat_messages_with_history(
                &mut history, // <- messages will be saved here
                ChatMessageRequest::new(
                    model.clone(),
                    vec![ChatMessage::user(prompt)], // <- You should provide only one message
                ),
            )
            .await;

        if let Ok(res) = res {
            println!("{}", res.message.content);
        } else {
            println!("Error: {:?}", res);
        }
    }
}
